

//+------------------------------------------------------------------------+
//|                                                  Chimera_indicator.ex4 |
//+------------------------------------------------------------------------+
#property copyright "Copyright invalid"
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 DeepPink
 
 
 
double ExtMapBuffer1[];
double ExtMapBuffer2[];

extern string     C_Signal1               = "====== Alligator =================================";
extern bool       U_UseSig1               = true;
extern int        P_JawsPer               = 6; //24-40
extern int        P_TeethPer              = 5; 
extern int        P_LipsPer               = 4; 
extern int        P_BandSpread            = 6;
extern int        P_BandShift             = 0;

extern string     C_Signal2               = "====== Price Action Channel========================";
extern bool       U_UseSig2               = true;
extern int        P_PACPer                = 5; 
extern int        P_PACShift              = 0; 

extern string     C_Signal3               = "====== Relative Strength Index======================";
extern bool       U_UseSig3               = true;
extern int        P_RSIPer                = 5; 
extern int        P_RSIVar                = 0; //0-5
extern int        P_RSIMax                = 18; //15-25

extern bool       PrefSettings            = false; 
 
int nShift=0;
 
int init()
  {
    SetIndexStyle(0, DRAW_ARROW, 0, 1);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
    SetIndexStyle(1, DRAW_ARROW, 0, 1);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
 
    
    switch(Period())
      {
        case     1: nShift = 1;   break;    
        case     5: nShift = 3;   break; 
        case    15: nShift = 5;   break; 
        case    30: nShift = 10;  break; 
        case    60: nShift = 15;  break; 
        case   240: nShift = 20;  break; 
        case  1440: nShift = 80;  break; 
        case 10080: nShift = 100; break; 
        case 43200: nShift = 200; break;               
      }
    return(0);
  }
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
    if(counted_bars < 0) return(-1);
    if(counted_bars > 0) counted_bars--;
    limit = Bars - counted_bars;
    for(int i = 0; i < limit; i++)
      {

//=====================Alligator========================
         bool BuySignal1=false, SellSignal1=false;


    if(U_UseSig1)
      {
//            int    JPr = MathRound((MathPow(1/MathSqrt(5))*(MathPow((1+MathSqrt(5))/2,P_JawsPer)-(MathPow((1-MathSqrt(5))/2,P_JawsPer)));
            int    JPr = MathRound((MathPow(1.6180339,P_JawsPer) - MathPow(0.6180339*(-1),P_JawsPer))/2.236067977);
            int    TPr = MathRound((MathPow(1.6180339,P_TeethPer)- MathPow(0.6180339*(-1),P_TeethPer))/2.236067977);
            int    LPr = MathRound((MathPow(1.6180339,P_LipsPer) - MathPow(0.6180339*(-1),P_LipsPer))/2.236067977);
            double BS = (10+P_BandSpread)/10;
            double Jaws0  = iMA(NULL,0,JPr,0,MODE_SMMA,PRICE_CLOSE,i);
            double Jaws1  = iMA(NULL,0,JPr,0,MODE_SMMA,PRICE_CLOSE,i+1);
            double Teeth0 = iMA(NULL,0,TPr,0,MODE_SMMA,PRICE_CLOSE,i);
            double Teeth1 = iMA(NULL,0,TPr,0,MODE_SMMA,PRICE_CLOSE,i+1);
            double Lips0  = iMA(NULL,0,LPr,0,MODE_SMMA,PRICE_CLOSE,i);
            double Lips1  = iMA(NULL,0,LPr,0,MODE_SMMA,PRICE_CLOSE,i+1);
            double UpperBand0  = iBands(NULL,0,34,BS,P_BandShift,PRICE_CLOSE,MODE_UPPER,i);
            double LowerBand0  = iBands(NULL,0,34,BS,P_BandShift,PRICE_CLOSE,MODE_LOWER,i);
            double UpperBand1  = iBands(NULL,0,34,BS,P_BandShift,PRICE_CLOSE,MODE_UPPER,i+1);
            double LowerBand1  = iBands(NULL,0,34,BS,P_BandShift,PRICE_CLOSE,MODE_LOWER,i+1);

            if 
               ( 
                  Lips0 >=  Lips1 
               &&((
                      Lips0 >= Teeth0
                   && Lips1 <  Teeth1
                   )
                  ||
                   (   
                      Lips0 >= Jaws0
                   && Lips1 <  Jaws1
                   )
                  ||
                   (
                      Lips0 >= Teeth0
                   && Lips1 <  Teeth1
                   && Lips0 >= Jaws0
                   && Lips1 <  Jaws1
                   )
                  ||
                   (  Lips0 > UpperBand0
                   && Lips1 < UpperBand1
                   ))
               )
               
                    {BuySignal1  = true;}

            if
               ( 
                  Lips0 <=  Lips1 
               &&((
                      Lips0 <= Teeth0
                   && Lips1 >  Teeth1
                   )
                  ||
                   (   
                      Lips0 <= Jaws0
                   && Lips1 >  Jaws1
                   )
                  ||
                   (
                      Lips0 <= Teeth0
                   && Lips1 >  Teeth1
                   && Lips0 <= Jaws0
                   && Lips1 >  Jaws1
                   )
                  ||
                   (
                      Lips0 < LowerBand0
                   && Lips1 > LowerBand1
                   ))
               )
               
                    {SellSignal1  = true;}
      }
    else
      {
    	  SellSignal1 =true;
        BuySignal1 =true;
      }

  //=====================Price Action Channel========================

    bool BuySignal2=false, SellSignal2=false;
    
    double HighPAC0 = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_HIGH,i);
    double LowPAC0  = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_LOW,i);
    double HighPAC1 = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_HIGH,i+1);
    double LowPAC1  = iMA(NULL,0,P_PACPer,P_PACShift,MODE_SMMA,PRICE_LOW,i+1);
    double haClose0 = (Open[i]+High[i]+Low[i]+Close[i])*(0.25);
    double haClose1 = (Open[i+1]+High[i+1]+Low[i+1]+Close[i+1])*(0.25);
    
  //  Print("HighPAC1: ",  HighPAC1, "LowPAC1: ", LowPAC1, "haClose1: ", haClose1);
   
    if(U_UseSig2)
      {
        if(
               haClose0 > HighPAC0
            && HighPAC0 > HighPAC1
            && haClose0 > haClose1
          ) 
                           {BuySignal2 = true;}
        if(
               haClose0 < HighPAC0
            && HighPAC0 < HighPAC1
            && haClose0 < haClose1
          )
                           {SellSignal2  = true;}
      }
    else
      {
    	  SellSignal2=true;
        BuySignal2 =true;
      }

    //=====================Relative Strength Index ======================  
     bool BuySignal3=false, SellSignal3=false;
   
            int    RSIP = MathRound((MathPow(1.6180339,P_RSIPer) - MathPow(0.6180339*(-1),P_RSIPer))/2.236067977);
            double RSILine = iRSI(NULL,0,RSIP,PRICE_CLOSE,i); 
        int    RSIHigh = 50 + P_RSIVar;
        int    RSILow  = 50 - P_RSIVar;
        int    RSITop  = 50 + P_RSIMax; 
        int    RSIBot  = 50 - P_RSIMax; 
     
    if(U_UseSig3)
      {
        if(
            RSILine > RSIHigh
         && RSILine < RSITop
          )
                        {BuySignal3 = true;}

        if(
            RSILine < RSILow
         && RSILine > RSIBot
          )
                        {SellSignal3 = true;}
      }
    else
      {
    	SellSignal3=true;
        BuySignal3 =true;
      }        

    //=====================Signal Accumulator====================  
         
 
         if(
              (SellSignal1==true)
            &&(SellSignal2==true)
            &&(SellSignal3==true)
           )   
              {
                     ExtMapBuffer2[i] = High[i] + nShift*Point;
              }
 
         if(
              (BuySignal1==true)
            &&(BuySignal2==true)
            &&(BuySignal3==true)
            ) 
              {
                     ExtMapBuffer1[i] = Low[i] - nShift*Point;
              }
        
      }
//----
    return(0);
  }
//+------------------------------------------------------------------+